<template>
  <div class="my-8">
    <ui-checkbox-group
      :options="toggleOptions"
      label="UiInputGrid config"
      hints="Use the following toggles to test the corresponding props."
    >
      <template #default="{ options }">
        <div class="flex gap-4 p-0">
          <ui-checkbox
            v-for="option of options as string[]"
            :key="option"
            v-model="toggle"
            :name="option"
            :value="option"
            :label="option"
            button
          />
        </div>
      </template>
    </ui-checkbox-group>
  </div>

  <ui-input-grid
    :label="recordSchema.label"
    hints="Bitte beantworten Sie jede Teilfrage!"
    :columns="gridCols + 1"
    :column-labels="
      itemOptions.map((option) => ({
        id: option.labelledById,
        label: option.label,
      }))
    "
    :sticky="toggle.includes('sticky') ? `${navbarHeight ?? 0}px` : ''"
  >
    <template #preColumnLabels="{ tooNarrow }">
      <ui-call-out v-if="tooNarrow" warning icon="⚠️">
        Too narrow, grid disabled
      </ui-call-out>
    </template>

    <template #default="{ tooNarrow }">
      <component
        :is="components[item.component]"
        v-for="item of getItems(!tooNarrow)"
        :key="item.model"
        v-model="model[item.model]"
        v-bind="item"
        :errors="toggle.includes('errors') && getErrorMessage(item.model)"
        :highlighted="toggle.includes('highlighted') && !isValid(item.model)"
        :is-resettable="!item.required"
        :is-grid-child="!tooNarrow"
      ></component>
    </template>
  </ui-input-grid>
</template>

<script lang="ts" setup>
import type { Component } from 'vue'
import { computed, inject, ref, Ref } from 'vue'
import UiInputGrid from '@/components/ui/InputGrid.vue'
import UiCheckbox from '@/components/ui/Checkbox.vue'
import UiCheckboxGroup from '@/components/ui/CheckboxGroup.vue'
import UiRadioGroup from '@/components/ui/RadioGroup.vue'
import recordSchema from './InputGridSchema'

const components: Record<string, string | Component> = {
  checkbox: UiCheckboxGroup,
  radio: UiRadioGroup,
}

const navbarHeight = inject<Ref<number>>('navbarHeight')

const model = ref<Record<string, string | number | Array<string | number>>>({})
const toggleOptions = ['sticky', 'highlighted', 'errors']
const toggle = ref(['sticky'])

const itemOptions = computed(() =>
  recordSchema.schema[0].options.map((option) => ({
    ...option,
    labelledById: `${recordSchema.model}:option-${option.id}`,
  })),
)

const getItems = (externalLabels: boolean) => {
  if (externalLabels) {
    return recordSchema.schema.map((item) => ({
      ...item,
      options: itemOptions.value,
    }))
  }

  return recordSchema.schema
}

const gridCols = computed(() =>
  itemOptions.value ? itemOptions.value.length + 1 : 0,
)

const isValid = (id: string) => {
  const value = model.value[id]

  return !(!value || (Array.isArray(value) && !value.length))
}

const getErrorMessage = (id: string) => {
  return isValid(id) ? '' : 'Bitte beantworten Sie diese Teilfrage!'
}
</script>
